// 2. od konce
#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <map>
using namespace std;


void load(vector<string> &slova, vector<string> &stranka) {
  int N,M;
  char buf[1032];
  scanf("%d ",&N);
  slova.resize(N);
  for (int i=0; i<N; i++) { scanf("%s",buf); slova[i]=buf; } 
  scanf("%d ",&M);
  stranka.resize(M);
  for (int i=0; i<M; i++) { scanf("%s",buf); stranka[i]=buf; } 
}
void output(const vector<string> &stranka, int zac, int kon) {
  if (zac==kon) { 
    printf("Chybna stranka!\n");
  } else {
    for (int i=zac; i<kon; i++) printf("%s\n",stranka[i].c_str());
  }
}
class trie {
  class __trieNode {
    public:
    int endsHere;
    __trieNode *son[32];
    __trieNode() { endsHere=-1; memset(son,0,sizeof(son)); }
  };

  __trieNode *root;
  int __size;

  public:
  trie() { root = new __trieNode(); __size = 0; }
  void insert(const string &S);
  int find(const string &S);
};

void trie::insert(const string &S) {
  __trieNode *kde = root;

  for (unsigned i=0; i<S.size(); i++) {
    int idx = S[i]-'a';
    if (! kde->son[idx]) kde->son[idx] = new __trieNode();
    kde = kde->son[idx];
  }

  kde->endsHere = __size++;
}

int trie::find(const string &S) {
  __trieNode *kde = root;
  
  for (unsigned i=0; i<S.size(); i++) {
    if (!kde) return -1;
    kde = kde->son[ S[i]-'a' ];
  }
  
  if (!kde) return -1;
  return kde->endsHere;
}

vector<int> toNumbers(const vector<string> &stranka, const vector<string> &slova) {
  int M = stranka.size(), N = slova.size();
  vector<int> res(M,0);
  trie T;
  for (int i=0; i<N; i++) T.insert( slova[i] );
  for (int i=0; i<M; i++) res[i] = 1 + T.find( stranka[i] );
  return res;
}
void najkratsiUsek( const vector<int> &cisla, const vector<int> &dlzky, int N, int &zaciatok, int &koniec ) {
  zaciatok = koniec = 0;
  int best = 987654321;
  int M = cisla.size();
  
  vector<int> pocet(N+1,0);
  int mame = 0;
  
  int z=0, k=0, dlzka=-1;
  while (1) {
    if (mame==N) {
      if (z==M) break;
      dlzka -= dlzky[z]+1;
      pocet[ cisla[z] ]--;
      if (cisla[z]) if (pocet[ cisla[z] ] == 0) mame--;
      z++;
    } else {
      if (k==M) break;
      dlzka += dlzky[k]+1;
      pocet[ cisla[k] ]++;
      if (cisla[k]) if (pocet[ cisla[k] ] == 1) mame++;
      k++;
    }

    if (mame == N) if (dlzka < best) { zaciatok=z; koniec=k; best=dlzka; }
  }
}

vector<string> slova, stranka;

#include <fcntl.h>

int main() {
  close(0);
  open("stranka.in", O_RDONLY);
  close(1);
  open("stranka.out", O_WRONLY|O_CREAT|O_TRUNC, 0666);
  close(2);
  open("/dev/null", O_WRONLY);

  cerr << "load..." << endl;
  load(slova,stranka);
  cerr << "toNumbers..." << endl;
  vector<int> cisla = toNumbers(stranka, slova);
  cerr << "dlzky..." << endl;
  vector<int> dlzky( stranka.size() );
  for (int i=0; i<(int)stranka.size(); i++) dlzky[i] = stranka[i].size();
  cerr << "najkratsiUsek..." << endl;
  int zac, kon;
  najkratsiUsek(cisla, dlzky, slova.size(), zac, kon);
  cerr << "output..." << endl;
  output(stranka,zac,kon);
  return 0;
}
