#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct sTRIE
{ 
	struct sTRIE* next['z'-'a'+1];
	int num;
} TRIE;

int tr_add(TRIE **t,int *seq,char *s)
{
	TRIE **p;
	if(!(*t)){
		//create
		*t=(TRIE*)malloc(sizeof(TRIE));
		memset(*t,0,sizeof(TRIE));
	}
	if (s[0]==0){
		//directly
		if((*t)->num<=0) (*t)->num=((*seq)++);
		return (*t)->num;		
	}
	p=&((*t)->next[s[0]-'a']);
	//dive deeper
	return tr_add(p,seq,s+1);	
}

//TRIE
TRIE *tr=NULL;
int trseq=1;
int N,M;

int found[10000];
int cfound=0;

char* slova[300000];
int tr_s[300000];

int main()
{
	FILE *f1,*f2;
	char buf[20000];
	int i,j,minlen,minbeg,minend,top,len;
	
	memset(found,0,sizeof(found));
	memset(slova,0,sizeof(slova));
	memset(tr_s,0,sizeof(tr_s));
	f1=fopen("stranka.in","rt");
	f2=fopen("stranka.out","wt");
	fscanf(f1,"%d",&N);
	for (i=0;i<N;i++){
		fscanf(f1,"%s",buf);
		j=tr_add(&tr,&trseq,buf);
//		printf("TR_Add: %d -- %s\n",j,buf);
	}
	fscanf(f1,"%d",&M);
	for (i=0;i<M;i++){
		fscanf(f1,"%s",buf);
		j=tr_add(&tr,&trseq,buf);
		slova[i]=(char*)malloc(sizeof(char)*(strlen(buf)+2));
		strcpy(slova[i],buf);
		tr_s[i]=j;
//		printf("TR_M: %d -- %s\n",tr_s[i],slova[i]);
	}
	top=0;
	minlen=20000000;
	len=-1;
	for (i=0;i<M;i++)
	{
		while((cfound<N)&&(top<M)){
			//add top
			if(tr_s[top]<=N){//W+
				if(found[tr_s[top]]==0) cfound++;
				found[tr_s[top]]++;
			}
			len+=strlen(slova[top])+1;
			top++;
		}
		if((cfound==N)&&(len<minlen)){
			minbeg=i;
			minlen=len;
			minend=top;
		}
		if(tr_s[i]<=N){//W-
			found[tr_s[i]]--;
			if(found[tr_s[i]]==0) cfound--;
		}		
		len-=strlen(slova[i])+1;
	}
	if(minlen>=20000000)
		fprintf(f2,"Chybna stranka!\n");
	else
		for(i=minbeg;i<minend;i++)
			fprintf(f2,"%s\n",slova[i]);
	fclose(f1);
	fclose(f2);
	
	return 0;
}

